// -*- compile-command: "g++ -g -c f256.cc" -*-
// d'apres le TER de L. Guichard
#include "f256.h"
#include <stdexcept>

short int f256::pmin;

unsigned char * f256::conv1=0;
unsigned char * f256::conv2=0;

void f256::remplissage_conv1et2(){
  if (!conv1){
    conv1=new unsigned char[256];
    conv2=new unsigned char[256];    
    pmin=(1<<8) | (1<<6) | (1<<5) | (1<<4) | 1;
  }
  int i;
  conv1[255] = 0;
  conv1[0] = 1;
  for(i = 1; i < 8; i++){
    conv1[i] = conv1[i-1] << 1;
  }
    
  for(i = 8; i < 255; i++){
    short int j=(conv1[i-1] << 1) ;
    if (j & 1<<8)
      j = j ^ pmin;
    conv1[i] = j;
  }
  for (i=0;i<256;++i)
    conv2[conv1[i]]=i;
}

f256::f256():i(0){ 
  if (!conv1 || !conv2) 
    remplissage_conv1et2(); 
}

f256::f256(int i_):i(i_){ 
  if (!conv1 || !conv2) 
    remplissage_conv1et2(); 
}


f256 inverse (const f256 & a){
  f256 res;
  if ( a.i == 0 )
    throw std::runtime_error("Inverse of 0");
  unsigned int tmp=- a.add2mult() + 255;
  res.mult2add( tmp % 255);
  return res; 
}


f256 operator - (const f256 & a){
  return a;
}

f256 operator * (const f256 & a,const f256 & b){
  // FIXME implement
  return a;
}

f256 operator + (const f256 & a,const f256 & b){
  // FIXME implement
  return a;
}

bool operator == (const f256 & a,const f256 & b){
  return a.i==b.i;
}


bool operator != (const f256 & a,const f256 & b){
  return a.i!=b.i;
}


std::istream & operator >> (std::istream & in,f256 & f){
  return in >> f.i;
}


std::ostream & operator << (std::ostream & out,const f256 & f){
  return out << f.i ;
}
