// -*- compile-command: "g++ -g -c f256.cc" -*-
// d'apres le TER de L. Guichard
#ifndef _F256_H
#define _F256_H
#include <iostream>

class f256 {
  int i; // representation additive (polynomiale bit a bit)
  static unsigned char * conv1 ; // tableau conversion mult->add
  static unsigned char * conv2 ; // tableau conversion add->mult
  static short int pmin; // polynome minimal primitif (sur 8 bits)
  void remplissage_conv1et2(); // creation des tableaux pour conversion
 public:
  f256(int i_);
  f256();
  int geti() const { return i;}
  // conversions mult->add et add->mult, ou on utilise 255 pour representer
  // 0 et sinon la puissance de l'element generateur x avec pmin(x)=0
  f256 mult2add(unsigned char C) { i=conv1[C]; return * this;} 
  unsigned char add2mult() const {
    if (i<0)
      return 255;
    return conv2[i];
  }
  friend f256 operator + (const f256 & a,const f256 & b);
  friend f256 operator * (const f256 & a,const f256 & b);
  friend f256 operator - (const f256 & a,const f256 & b);
  friend f256 operator / (const f256 & a,const f256 & b);
  friend f256 inverse (const f256 & a);
  friend f256 operator - (const f256 & a);
  friend bool operator == (const f256 & a,const f256 & b);
  friend bool operator != (const f256 & a,const f256 & b);
  friend std::istream & operator >> (std::istream & in,f256 & f);
  friend std::ostream & operator << (std::ostream & out,const f256 & f);
};

inline f256 mult_f256(int i){ f256 f; return f.mult2add(i);};
inline int f256_mult(const f256 & f){ return f.add2mult();};
inline f256 add_f256(int i){ f256 f(i); return f;} ;
inline int f256_add(const f256 & f){return f.geti();};
f256 operator + (const f256 & a,const f256 & b);
f256 operator * (const f256 & a,const f256 & b);
f256 operator - (const f256 & a,const f256 & b);
f256 operator / (const f256 & a,const f256 & b);
f256 inverse (const f256 & a);
f256 operator - (const f256 & a);
bool operator == (const f256 & a,const f256 & b);
bool operator != (const f256 & a,const f256 & b);
std::istream & operator >> (std::istream & in,f256 & f);
std::ostream & operator << (std::ostream & out,const f256 & f);

#endif // _F256_H
